--https://docs.microsoft.com/en-us/sql/relational-databases/system-dynamic-management-views/sys-dm-db-index-operational-stats-transact-sql?view=sql-server-2017

--Use Default instance
--Demo all columns
--Will return rows only of there are scans or seeks
	USE AdventureWorks2014

	SELECT *
	FROM sys.dm_db_index_operational_stats( DB_ID('adventureworks2014'), 1237579447, NULL, NULL);    
	GO

	Select *
	from sys.dm_db_index_usage_stats
	where object_id = 1237579447

--Demo this statement
--Show indexes on the HumanResources.Employee table
--Run both statements

	SELECT 
		  object_id
		, range_scan_count 
		, index_id
		, singleton_lookup_count
	FROM sys.dm_db_index_operational_stats( DB_ID('adventureworks2014'), 1237579447, NULL, NULL);    
	GO
	
	Select *
	from sys.dm_db_index_usage_stats
	where object_id = 1237579447

--Demo to confirm the object name
	SELECT * 
	FROM sysobjects
	WHERE id = 1237579447
	
	SELECT
		index_id,
		name AS Index_Name,
		type_desc  As Index_Type,
		is_unique,
		OBJECT_NAME(object_id) As Table_Name
	FROM
		sys.indexes
	WHERE
		is_hypothetical = 0 AND
		index_id != 0 AND
		object_id = OBJECT_ID('humanresources.employee');

