--SQL Statistics Object


--USE NAMED INSTANCE

SELECT    [object_name]
		, counter_name
		, cntr_value
		, cntr_type
FROM sys.dm_os_performance_counters
WHERE [counter_name] IN (	  
				
							 'Batch Requests/sec'
							, 'SQL Compilations/sec'
							, 'SQL re-Compilations/sec'
							)
							AND instance_name IN ('','_total')

--the number of requests for available database pages are suspended 
--requests stall because there are 
--no buffers available
--Should be 2 or less


	
	DECLARE @iCount AS SMALLINT
	CREATE TABLE #BatReq
				(  Currentvalue		 INT
				 , DateTimeOfCapture Datetime)
	SET @iCount = 1

	WHILE @iCount < 3
		BEGIN

			INSERT INTO #BatReq
			SELECT    cntr_value 
					, GETDATE()
			FROM sys.dm_os_performance_counters
			WHERE counter_name = 'Batch Requests/sec'

			WAITFOR DELAY '00:00:05'

			SET @icount = @icount + 1
		END

	SELECT   'Batch Requests/sec' AS 'CounterName'
			,* 
	FROM #BatReq






--Average Per Second

	DECLARE @iCount1 AS SMALLINT
	CREATE TABLE #SQLComp
				(  Currentvalue		 INT
				 , DateTimeOfCapture Datetime)
	SET @iCount1 = 1

	WHILE @iCount1 < 4
		BEGIN

			INSERT INTO #SQLComp
			SELECT    cntr_value 
					, GETDATE()
			FROM sys.dm_os_performance_counters
			WHERE counter_name = 'SQL Compilations/sec'

			WAITFOR DELAY '00:00:10'

			SET @icount1 = @icount1 + 1
		END

	SELECT   'SQL Compilations/sec' AS 'CounterName'
			,* 
	FROM #SQLComp

	DROP TABLE #BatReq
	DROP TABLE #SQLComp
