

--USE NAMED INSTANCE

--From https://www.sqlshack.com/insight-into-the-sql-server-buffer-cache/
--Number of database pages by database

SELECT
    databases.name AS 'DatabaseName',
	Count(*) 'NumberOfPages',
    COUNT(*) * 8 / 1024 AS 'MBUsed'
FROM sys.dm_os_buffer_descriptors
INNER JOIN sys.databases
ON databases.database_id = dm_os_buffer_descriptors.database_id
GROUP BY databases.name
ORDER BY MBUsed DESC;



--From Microsoft
--https://docs.microsoft.com/en-us/sql/relational-databases/system-dynamic-management-views/sys-dm-os-buffer-descriptors-transact-sql?view=sql-server-2017

--Restart the service
--Run once to show that in memory tables are not include
--Query Shopping cart, run again
--query NameOfEmp, ,run again

USE IMOLTP

SELECT COUNT(*)AS cached_pages_count   
    ,name ,index_id, row_count
FROM sys.dm_os_buffer_descriptors AS bd   
    INNER JOIN   
    (  
        SELECT object_name(object_id) AS name   
            ,index_id ,allocation_unit_id  
        FROM sys.allocation_units AS au  
            INNER JOIN sys.partitions AS p   
                ON au.container_id = p.hobt_id   
                    AND (au.type = 1 OR au.type = 3)  
        UNION ALL  
        SELECT object_name(object_id) AS name     
            ,index_id, allocation_unit_id  
        FROM sys.allocation_units AS au  
            INNER JOIN sys.partitions AS p   
                ON au.container_id = p.partition_id   
                    AND au.type = 2  
    ) AS obj   
        ON bd.allocation_unit_id = obj.allocation_unit_id  
WHERE database_id = DB_ID() and Name not like 'sys%' 
GROUP BY name, index_id, row_count
ORDER BY cached_pages_count DESC;  