PRINT '========================================================================================================================='
PRINT ''
PRINT ''
PRINT 'Get Activity By Hour, past 8 weeks, only for databases with transaction log backups'
SET NOCOUNT ON
PRINT ''
PRINT ''
PRINT ''
SELECT 'Activity by Hour'  AS 'Setting',
		@@servername AS 'Server', 
		a.database_name,
		DATEPART(HOUR,a.backup_start_date) AS 'Hour',
		convert(int,AVG(CASE WHEN charindex('Monday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End))  as 'Mon_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Tuesday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Tue_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Wednesday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Wed_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Thursday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Thu_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Friday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Fri_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Saturday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Sat_size(MB)',
		convert(int,AVG(CASE WHEN charindex('Sunday',datename(weekday,a.backup_start_date)) > 0 then ceiling(a.backup_size/1000000.00) End)) as 'Sun_size(MB)'
		,MIN(a.backup_start_date ) as 'From:'
		,MAX(a.backup_start_date ) as 'To:'
		,COUNT(*)
FROM msdb.dbo.backupset a (NOLOCK)
WHERE a.type = 'L' --log backups
	AND a.backup_start_date 
		BETWEEN DATEADD(WEEK, DATEDIFF(WEEK,0,GETDATE())-8 ,0) AND GETDATE() --8 WEEKs back
GROUP BY a.database_name, 
	DATEPART(HOUR,a.backup_start_date)
ORDER BY a.database_name, 
	DATEPART(HOUR,a.backup_start_date)

IF @@Rowcount = 0
	BEGIN
		Select 'No Transaction Log backups are taking place' AS 'Status'
	END