--Look for the TestFragmentation table in the AdventureWorks database		
		
		PRINT '========================================================================================================================='
		PRINT ''
		PRINT ''
		PRINT 'Gets Index Fragmentation status, only for greater than 20% fragmented'
		SET NOCOUNT ON
		PRINT ''
		PRINT ''
		PRINT '' 
		CREATE TABLE #IndexFragmentation
				( ItemStatus       NVARCHAR(100),
					DatabaseName     NVARCHAR(128),
					TableName        NVARCHAR(128),
					IndexName        VARCHAR(100),
					AvgFragmentation DECIMAL(10,2),
					PageCount        INT,
					IndexType        VARCHAR(100))
		EXECUTE master.sys.sp_MSforeachdb 'USE [?] INSERT INTO #IndexFragmentation
										SELECT
											''Gets Index Fragmentation status, only for greater than 20% fragmented'' AS ''Status''
											, DB_Name()
											, OBJECT_NAME(object_id) AS Table_Name
											, (SELECT name FROM sys.indexes WHERE object_id = i.object_id and index_id = i.index_id) as Index_Name
											, avg_fragmentation_in_percent, page_count
											, index_type_desc
											FROM sys.dm_db_index_physical_stats(DB_ID(), NULL, NULL, NULL, NULL) i
											WHERE avg_fragmentation_in_percent > 20
											ORDER BY avg_fragmentation_in_percent DESC '
		Select * from #IndexFragmentation

		DROP TABLE #IndexFragmentation