--Find number of Forwarded Records
USE AdventureWorks2014

SELECT    OBJECT_NAME(object_id) AS 'Table'
		, forwarded_record_count
		, avg_fragmentation_in_percent
FROM sys.dm_db_index_physical_stats
				(DB_ID(), NULL, NULL, NULL, 'DETAILED')
WHERE forwarded_record_count IS NOT NULL
GO

--Since the system was last started
SELECT *
FROM sys.dm_os_performance_counters
WHERE counter_name = 'Forwarded Records/sec'

--Create more forward records
--Run above code after to show increase
USE AdventureWorks2014

BEGIN TRAN

UPDATE [Production].[ProductFilteredStatsUpdateExample]
SET name = Name + 'Testing11'
WHERE [ProductID] between 300 and 500

ROLLBACK
COMMIT

--Fix Forwarded Records

ALTER TABLE [Production].[ProductFilteredStatsUpdateExample] REBUILD
GO

