CREATE TABLE TestEncryptionPassCert
([Name]                            [varchar] (256)
,[CreditCardNumber]                [varchar](16)
,[EncryptedCreditCardNumber]       [varbinary](max))
GO

INSERT INTO TestEncryptionPassCert ([Name], [CreditCardNumber])
SELECT 'Simon Jones', '9876123456782378'
UNION ALL
SELECT 'Kim Brian', '1234567898765432'
GO


CREATE CERTIFICATE MyCertificate

   WITH SUBJECT = 'Demo Cert', 
   EXPIRY_DATE = '10/31/2050'
GO

drop certificate MyCertificate
drop SYMMETRIC KEY MySymmetricKeyCert



SELECT * FROM sys.certificates
--You either encrypt the data directly using certificate
--UPDATE [dbo].[TestEncryptionPassCert]
--SET [EncryptedCreditCardNumber] = ENCRYPTBYCERT(CERT_ID('MyCertificate'), CreditCardNumber)
--GO


SET STATISTICS TIME  ON
SELECT Name,CONVERT([varchar](16), 
            DECRYPTBYCERT(CERT_ID('MyCertificate')
           ,EncryptedCreditCardNumber)) AS [CreditCardNumber]
FROM [dbo].[TestEncryptionPassCert]
GO

SET STATISTICS TIME  ON
SELECT Name, CreditCardNumber
FROM [dbo].[TestEncryptionPassCert]
GO
