/*****************************************************************/

--Get Traces

		SELECT DISTINCT *
		FROM ::fn_trace_getinfo(default)
		
		-- 1 = Trace options. For more information, see @options in sp_trace_create (Transact-SQL).

		-- 2 = File name

		-- 3 = Max size

		-- 4 = Stop time

		-- 5 = Current trace status. 0 = stopped. 1 = running. 

/************************************************************************/
--Temp table to hold the eventname
--Used to build the ADD EVENT string

			CREATE TABLE #tempEvent
				(Eventid		INT,
				 exActionName	VARCHAR(100))

			INSERT INTO #tempEvent
			SELECT DISTINCT el.eventid,ec.xe_action_name 
			FROM (sys.fn_trace_geteventinfo(1) AS el
				LEFT OUTER JOIN sys.trace_xe_event_map AS em
					ON el.eventid = em.trace_event_id)
				LEFT OUTER JOIN sys.trace_xe_action_map AS ec
					ON el.columnid = ec.trace_column_id
			WHERE em.xe_event_name IS NOT NULL 
				AND ec.xe_action_name IS NOT NULL 
 
/************************************************************************/
--Review the data in the temp table above

		SELECT  * FROM #tempEvent
		ORDER BY 1

/************************************************************************/
--Added the actual event actions to a table

		CREATE TABLE #EEeventFromTrace
			(	  eventid		INT
				, packagename	VARCHAR(50)
				, event			VARCHAR(100)
				, ColumnID		INT
				, action		VARCHAR(100)
				, ActionEE		VARCHAR(7000))
		INSERT INTO #EEeventFromTrace
		SELECT DISTINCT	  el.eventid
						, em.package_name
						, em.xe_event_name AS 'event'
						, el.columnid
						, ec.xe_action_name AS 'action'
						, Actions = JSON_VALUE(
							REPLACE(
								(SELECT _ = em.package_name + '.' + t.exActionName 
								 FROM #tempEvent t 
								 WHERE t.eventid = el.eventid  FOR JSON PATH)
									,'"},{"_":"',', '),'$[0]._'
									)
		FROM (sys.fn_trace_geteventinfo(1) AS el
			LEFT OUTER JOIN sys.trace_xe_event_map AS em
			  ON el.eventid = em.trace_event_id)
			LEFT OUTER JOIN sys.trace_xe_action_map AS ec
			  ON el.columnid = ec.trace_column_id
		WHERE em.xe_event_name IS NOT NULL 
			AND ec.xe_action_name IS NOT NULL;

		SELECT *
		FROM #EEeventFromTrace

/************************************************************************/
--Used to build the string for the Creation of the events

		SELECT DISTINCT
		   '
				ADD EVENT ' + e.packagename + '.' + e.event + '
				   (ACTION
					  (
					' + e.ActionEE +
					  ') 
				   ), '
		FROM #EEeventFromTrace e