-- Create XML variable to hold Target Data

DECLARE @target_data XML
SELECT --@target_data = 
    CAST(target_data AS XML), *
FROM master.sys.dm_xe_sessions AS s 
JOIN master.sys.dm_xe_session_targets AS t 
    ON t.event_session_address = s.address
WHERE s.name = 'execution_timeout'
  AND t.target_name = 'event_file'

  SELECT 
    @target_data.value('(PairingTarget/@orphanCount)[1]', 'int') AS orphanCount,
    @target_data.value('(PairingTarget/@matchedCount)[1]', 'int') AS matchedCount,
    @target_data.value('(PairingTarget/@memoryPressureDroppedCount)[1]', 'int') AS memoryPressureDroppedCount

-- Query the XML variable to get the Target Data

SELECT 

    DATEADD(hh, 
            DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP), 
            n.value('(event/@timestamp)[1]', 'datetime2')) AS [timestamp],
	n.value('(event/action[@name="username"]/value)[1]', 'varchar(100)') as UserName,
	n.value('(event/action[@name="client_hostname"]/value)[1]', 'varchar(100)') as client_hostname,
		n.value('(event/action[@name="client_app_name"]/value)[1]', 'varchar(100)') as client_app_name,
    n.value('(event/action[@name="sql_text"]/value)[1]', 'varchar(max)') as sql_text ,
	 n.value('(event/data[@name="statement"]/value)[1]', 'varchar(max)') as statement 
FROM
(    SELECT td.query('.') as n
FROM @target_data.nodes('PairingTarget/event') AS q(td)
) as tab
inner join master.sys.databases d
	on n.value('(event/data[@name="source_database_id"]/value)[1]', 'int') = d.database_id
	where   
								Convert(date,DATEADD(hh, 
								DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP), 
								n.value('(event/@timestamp)[1]', 'datetime2'))) =  convert(date,DATEADD(hh, DATEDIFF(hh, GETUTCDATE(), CURRENT_TIMESTAMP),dateadd(day,-1, getutcdate())))
					
ORDER BY 5 desc
GO